#if !defined(__GSGC_H)
#define __GSGC_H

#if !defined(GC_PTR)
# define GC_PTR		void *
#endif

#include <sys/types.h>

#define		GC_ATOMIC	0
#define		GC_POINTERS	(-1L)

typedef struct GarbageCollector	GarbageCollector;
typedef size_t			GC_StackMarker;
typedef void			(*GC_Callback)(struct GarbageCollector *gc);

#if !defined(GC_API)
# define GC_API
#endif

GC_API GarbageCollector *GC_new(size_t nbytes);

#define			GC_BEGIN(AGC)		GC_StackMarker __GC__stack_marker__= GC_begin(AGC)
#define			GC_END(AGC)		GC_end(AGC, __GC__stack_marker__)

GC_API void		GC_add_root(GarbageCollector *gc, GC_PTR *ptr);

GC_API GC_StackMarker	GC_begin(GarbageCollector *gc);
GC_API void		GC_push_root(GarbageCollector *gc, GC_PTR *ptr, char *memo);
GC_API void		GC_end(GarbageCollector *gc, GC_StackMarker mark);

GC_API GC_PTR		GC_check_store(GarbageCollector *gc, GC_PTR dst, GC_PTR src);

#if 0
GC_API void		GC_set_callback(GarbageCollector *gc, GC_Callback fn);
#endif

GC_API GC_PTR		GC_malloc(GarbageCollector *gc, size_t nbytes);
GC_API GC_PTR		GC_malloc_atomic(GarbageCollector *gc, size_t nbytes);
GC_API GC_PTR		GC_malloc_mapped(GarbageCollector *gc, size_t nbytes, long map);
GC_API void		GC_collect(GarbageCollector *gc);

GC_API int		GC_size(GC_PTR ptr);
GC_API long		GC_is_pointers(GC_PTR ptr);

GC_API void		GC_delete(GarbageCollector *gc);

#endif /* __GSGC_H */
